<?php

declare(strict_types=1);

namespace Slavlee\T3campusYtseriesV11\Controller;


/**
 * This file is part of the "TYPO3 11 Example Extension for TYPO3 Campus" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2022 Kevin Chileong Lee <campus@slavlee.de>, Slavlee
 */

/**
 * PageCityController
 */
class PageCityController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * pageCityRepository
     *
     * @var \Slavlee\T3campusYtseriesV11\Domain\Repository\PageCityRepository
     */
    protected $pageCityRepository = null;

    /**
     * @param \Slavlee\T3campusYtseriesV11\Domain\Repository\PageCityRepository $pageCityRepository
     */
    public function injectPageCityRepository(\Slavlee\T3campusYtseriesV11\Domain\Repository\PageCityRepository $pageCityRepository)
    {
        $this->pageCityRepository = $pageCityRepository;
    }
    
    /**
     * Init listAction
     * @return void
     */
    public function initializeListAction()
    {
        $querySettings = $this->pageCityRepository->createQuery()->getQuerySettings();
        $querySettings->setRespectStoragePage(FALSE);
        $this->pageCityRepository->setDefaultQuerySettings($querySettings);
    }

    /**
     * action list
     *
     * @return \Psr\Http\Message\ResponseInterface
     */
    public function listAction(): \Psr\Http\Message\ResponseInterface
    {
        $pageCities = $this->pageCityRepository->findAll();
        $this->view->assign('pageCities', $pageCities);
        return $this->htmlResponse();
    }
}
