<?php
namespace Slavlee\T3campusYtseriesV11\ExpressionLanguage;

use Symfony\Component\ExpressionLanguage\ExpressionFunction;
use Symfony\Component\ExpressionLanguage\ExpressionFunctionProviderInterface;

class SlavleeTSConditionFunctionsProvider implements ExpressionFunctionProviderInterface
{
    public function getFunctions()
    {
        return [
            $this->getIsLoadedFunction(),
        ];
    }
    
    /**
     * Register isLoaded in TypoScript
     * @return ExpressionFunction
     */
    protected function getIsLoadedFunction(): ExpressionFunction
    {
        return new ExpressionFunction('isLoaded', function () {
            // Not implemented, we only use the evaluator
        }, function ($existingVariables, $className) {
            return \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded($className);
        });
    }
}