<?php
declare(strict_types=1);

namespace Slavlee\T3campusYtseriesV11\Tests\Unit\Controller;

use PHPUnit\Framework\MockObject\MockObject;
use TYPO3\TestingFramework\Core\AccessibleObjectInterface;
use TYPO3\TestingFramework\Core\Unit\UnitTestCase;
use TYPO3Fluid\Fluid\View\ViewInterface;

/**
 * Test case
 *
 * @author Kevin Chileong Lee <campus@slavlee.de>
 */
class PageCityControllerTest extends UnitTestCase
{
    /**
     * @var \Slavlee\T3campusYtseriesV11\Controller\PageCityController|MockObject|AccessibleObjectInterface
     */
    protected $subject;

    protected function setUp(): void
    {
        parent::setUp();
        $this->subject = $this->getMockBuilder($this->buildAccessibleProxy(\Slavlee\T3campusYtseriesV11\Controller\PageCityController::class))
            ->onlyMethods(['redirect', 'forward', 'addFlashMessage'])
            ->disableOriginalConstructor()
            ->getMock();
    }

    protected function tearDown(): void
    {
        parent::tearDown();
    }

    /**
     * @test
     */
    public function listActionFetchesAllPageCitiesFromRepositoryAndAssignsThemToView(): void
    {
        $allPageCities = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->disableOriginalConstructor()
            ->getMock();

        $pageCityRepository = $this->getMockBuilder(\Slavlee\T3campusYtseriesV11\Domain\Repository\PageCityRepository::class)
            ->onlyMethods(['findAll'])
            ->disableOriginalConstructor()
            ->getMock();
        $pageCityRepository->expects(self::once())->method('findAll')->will(self::returnValue($allPageCities));
        $this->subject->_set('pageCityRepository', $pageCityRepository);

        $view = $this->getMockBuilder(ViewInterface::class)->getMock();
        $view->expects(self::once())->method('assign')->with('pageCities', $allPageCities);
        $this->subject->_set('view', $view);

        $this->subject->listAction();
    }
}
