<?php
declare(strict_types=1);

namespace Slavlee\T3campusYtseriesV11\Tests\Unit\Domain\Model;

use PHPUnit\Framework\MockObject\MockObject;
use TYPO3\TestingFramework\Core\AccessibleObjectInterface;
use TYPO3\TestingFramework\Core\Unit\UnitTestCase;

/**
 * Test case
 *
 * @author Kevin Chileong Lee <campus@slavlee.de>
 */
class PageCityTest extends UnitTestCase
{
    /**
     * @var \Slavlee\T3campusYtseriesV11\Domain\Model\PageCity|MockObject|AccessibleObjectInterface
     */
    protected $subject;

    protected function setUp(): void
    {
        parent::setUp();

        $this->subject = $this->getAccessibleMock(
            \Slavlee\T3campusYtseriesV11\Domain\Model\PageCity::class,
            ['dummy']
        );
    }

    protected function tearDown(): void
    {
        parent::tearDown();
    }

    /**
     * @test
     */
    public function getCityReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getCity()
        );
    }

    /**
     * @test
     */
    public function setCityForStringSetsCity(): void
    {
        $this->subject->setCity('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('city'));
    }

    /**
     * @test
     */
    public function getPostcodeReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getPostcode()
        );
    }

    /**
     * @test
     */
    public function setPostcodeForStringSetsPostcode(): void
    {
        $this->subject->setPostcode('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('postcode'));
    }

    /**
     * @test
     */
    public function getStateReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getState()
        );
    }

    /**
     * @test
     */
    public function setStateForStringSetsState(): void
    {
        $this->subject->setState('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('state'));
    }

    /**
     * @test
     */
    public function getCountryReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getCountry()
        );
    }

    /**
     * @test
     */
    public function setCountryForStringSetsCountry(): void
    {
        $this->subject->setCountry('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('country'));
    }
}
